//
//  InternetTime.m
//  -- version 0.3 --
//
//  Created by Pigmon on Thu Oct 26 2000.
//  Last Updated by Pigmon on Thu Apr 07 2001.
//  Copyright (c) 2000,2001 Pigmon. All rights reserved.
//                     mailto:pigmon@mac.com
//
//  ztF@ȉ̍ڂɏ]ꍇA̏ꍇA{\[XR[hRɕEς邱Ƃł܂B
//                E@ς\[XR[h񎟔ztꍇA̎|KLĉB
//                  (ł΃o[WԍAvP[Vŋʂł悤ɂĉj

#import "InternetTime.h"


@implementation InternetTime

-(id)init
{
    NSDate*	aDate;

    [super init];

    if ( aNSDate != NULL ) {
        aNSDate = [aNSDate init];
        return self;
    }
    
    
    aDate = [[[NSDate alloc] init] autorelease];
    aNSDate = [aDate retain];
        
    return self;
}

-(id)initWithDate:(NSDate*)aDate
{
    [super init];
    
    if ( aNSDate != NULL ) {
        [aNSDate autorelease];
    }
    
    aNSDate = [aDate retain];
    
    return self;
}

-(void)dealloc
{
    [aNSDate release];
    [super dealloc];
}

-(int)itIntValue
{
    return [self itIntValueWithDate:aNSDate];
}


-(int)itIntValueWithDate:(NSDate*)aDate;
{
    NSTimeInterval	tempInterval;
    int			result;
    
    tempInterval = [aDate timeIntervalSince1970];
    tempInterval += 3600.0;    
    tempInterval = tempInterval - 86400.0 * (long)(tempInterval / 86400.0);
    result = floor( tempInterval * 1000.0 / 86400.0 );
    
    return result;
}


-(NSString*)itStringValue
{
    return [self itStringValueWithDate:aNSDate];
}

-(NSString* )itStringValueWithDate:(NSDate*)aDate
{
    int			aInternetTime;
    NSString*		aITString;
    
    aInternetTime = [self itIntValueWithDate: aDate ];
    
    aITString = [NSString localizedStringWithFormat:@"%.3d", aInternetTime];
    
    return aITString;
}

-(NSString* )itDescriptionWithCalendarFormat:(NSString*)formatString
{
    return [aNSDate descriptionWithCalendarFormat: formatString
                    timeZone:[NSTimeZone timeZoneForSecondsFromGMT:3600] locale:nil];
}

-(NSString* )ltDescriptionWithCalendarFormat:(NSString*)formatString
{
    return [aNSDate descriptionWithCalendarFormat: formatString
                    timeZone:nil locale:nil];
}

-(NSTimeInterval)timeIntervalSince1970
{
    return [aNSDate timeIntervalSince1970];
}
@end
